﻿using Syncfusion.Data;
using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Windows;

namespace Test.Views
{

    public partial class MainWindow : Window
    {

        public List<DataStruct1> TableData1;
        public List<DataStruct2> TableData2;
        public List<DataStruct3> TableData3;

        public MainWindow()
        {

            InitializeComponent();
           
        }

        private void LoadData(object sender, RoutedEventArgs e)
        {

            Random rnd = new Random();
            DateTime Date = DateTime.Now;

            this.TableData1 = this.GenerateData1(rnd, Date);
            this.TableData2 = this.GenerateData2(rnd, Date);
            this.TableData3 = this.GenerateData3(rnd, Date);

            foreach (DataStruct1 D in this.TableData1) 
            {
                D.AddSource2(this.TableData2);
                D.AddSource3(this.TableData3);
            }

            foreach (DataStruct2 D in this.TableData2) 
            {
                D.AddSource1(this.TableData1);
                D.AddSource3(this.TableData3);
            }

            this.grid1.ItemsSource = this.TableData1;
            this.grid2.ItemsSource = this.TableData2;
            this.grid3.ItemsSource = this.TableData3;

        }

        private List<DataStruct1> GenerateData1(Random rnd, DateTime Date)
        {

            List <DataStruct1> Data = new List<DataStruct1>();

            for (int i = 1; i <= 62; i++)
            {

                Data.Add(new DataStruct1()
                {
                    Date = Date.AddDays(i),

                    G = rnd.Next(1, 999999) * 0.95,
                    H = rnd.Next(1, 999999) * 0.95,
                    I = rnd.Next(1, 999999) * 0.95,
                    J = rnd.Next(1, 999999) * 0.95,
                    K = rnd.Next(1, 999999) * 0.95,
                    L = rnd.Next(1, 999999) * 0.95,
                    M = rnd.Next(1, 999999) * 0.95,
                    N = rnd.Next(1, 999999) * 0.95,
                    O = rnd.Next(1, 999999) * 0.95,
                    P = rnd.Next(1, 999999) * 0.95,
                    Q = rnd.Next(1, 999999) * 0.95,
                    R = rnd.Next(1, 999999) * 0.95,
                    S = rnd.Next(1, 999999) * 0.95,
                    T = rnd.Next(1, 999999) * 0.95,
                    U = rnd.Next(1, 999999) * 0.95,
                    V = rnd.Next(1, 999999) * 0.95,
                    W = rnd.Next(1, 999999) * 0.95,
                    X = rnd.Next(1, 999999) * 0.95,
                    Y = rnd.Next(1, 999999) * 0.95,
                    Z = rnd.Next(1, 999999) * 0.95,
                    AA = rnd.Next(1, 999999) * 0.95,
                    AB = rnd.Next(1, 999999) * 0.95,
                    AC = rnd.Next(1, 999999) * 0.95,
                    AD = rnd.Next(1, 999999) * 0.95,
                    AE = rnd.Next(1, 999999) * 0.95,
                    AF = rnd.Next(1, 999999) * 0.95,
                    AG = rnd.Next(1, 999999) * 0.95,
                    AH = rnd.Next(1, 999999) * 0.95,
                    AI = rnd.Next(1, 999999) * 0.95,
                    AJ = rnd.Next(1, 999999) * 0.95,
                    AK = rnd.Next(1, 999999) * 0.95,
                    AL = rnd.Next(1, 999999) * 0.95,
                    AM = rnd.Next(1, 999999) * 0.95,
                    AN = rnd.Next(1, 999999) * 0.95,
                    AO = rnd.Next(1, 999999) * 0.95,
                    AP = rnd.Next(1, 999999) * 0.95,
                    AQ = rnd.Next(1, 999999) * 0.95,
                    AR = rnd.Next(1, 999999) * 0.95,
                    AS = rnd.Next(1, 999999) * 0.95,
                    AT = rnd.Next(1, 999999) * 0.95,
                    AU = rnd.Next(1, 999999) * 0.95,
                    AV = rnd.Next(1, 999999) * 0.95,
                    AW = rnd.Next(1, 999999) * 0.95,
                    AX = rnd.Next(1, 999999) * 0.95,
                    AY = rnd.Next(1, 999999) * 0.95,
                    AZ = rnd.Next(1, 999999) * 0.95,
                    BA = rnd.Next(1, 999999) * 0.95,
                    BB = rnd.Next(1, 999999) * 0.95,
                    BC = rnd.Next(1, 999999) * 0.95,
                    BD = rnd.Next(1, 999999) * 0.95,
                    BE = rnd.Next(1, 999999) * 0.95,
                    BF = rnd.Next(1, 999999) * 0.95,
                    BG = rnd.Next(1, 999999) * 0.95,
                    BH = rnd.Next(1, 999999) * 0.95,
                    BI = rnd.Next(1, 999999) * 0.95,
                    BJ = rnd.Next(1, 999999) * 0.95,
                    BK = rnd.Next(1, 999999) * 0.95,
                    BL = rnd.Next(1, 999999) * 0.95,
                    BM = rnd.Next(1, 999999) * 0.95,
                    BN = rnd.Next(1, 999999) * 0.95,
                    BO = rnd.Next(1, 999999) * 0.95,
                    BP = rnd.Next(1, 999999) * 0.95,
                    BQ = rnd.Next(1, 999999) * 0.95,
                    BR = rnd.Next(1, 999999) * 0.95,
                    BS = rnd.Next(1, 999999) * 0.95,
                    BT = rnd.Next(1, 999999) * 0.95,
                    BU = rnd.Next(1, 999999) * 0.95,
                    BV = rnd.Next(1, 999999) * 0.95,
                    BW = rnd.Next(1, 999999) * 0.95,
                    BX = rnd.Next(1, 999999) * 0.95,
                    BY = rnd.Next(1, 999999) * 0.95,
                    BZ = rnd.Next(1, 999999) * 0.95,
                    CA = rnd.Next(1, 999999) * 0.95,
                    CB = rnd.Next(1, 999999) * 0.95,
                    CC = rnd.Next(1, 999999) * 0.95,
                    CD = rnd.Next(1, 999999) * 0.95,
                    CE = rnd.Next(1, 999999) * 0.95,
                    CF = rnd.Next(1, 999999) * 0.95,
                    CG = rnd.Next(1, 999999) * 0.95,
                    CH = rnd.Next(1, 999999) * 0.95,
                    CI = rnd.Next(1, 999999) * 0.95,
                    CJ = rnd.Next(1, 999999) * 0.95,
                    CK = rnd.Next(1, 999999) * 0.95,
                    CL = rnd.Next(1, 999999) * 0.95,
                    CM = rnd.Next(1, 999999) * 0.95,
                    CN = rnd.Next(1, 999999) * 0.95,
                    CO = rnd.Next(1, 999999) * 0.95,
                    CP = rnd.Next(1, 999999) * 0.95,
                    CQ = rnd.Next(1, 999999) * 0.95,
                    CR = rnd.Next(1, 999999) * 0.95,
                    CS = rnd.Next(1, 999999) * 0.95,
                    CT = rnd.Next(1, 999999) * 0.95,
                    CU = rnd.Next(1, 999999) * 0.95,
                    CV = rnd.Next(1, 999999) * 0.95,
                    CW = rnd.Next(1, 999999) * 0.95,
                    CX = rnd.Next(1, 999999) * 0.95,
                    CY = rnd.Next(1, 999999) * 0.95,
                    CZ = rnd.Next(1, 999999) * 0.95
                });

            }

            return Data;

        }

        private List<DataStruct2> GenerateData2(Random rnd, DateTime Date)
        {

            List<DataStruct2> Data = new List<DataStruct2>();

            for (int i = 1; i <= 62; i++)
            {

                Data.Add(new DataStruct2()
                {
                    Date = Date.AddDays(i),
                    A = rnd.Next(1, 999999) * 0.95,
                    B = rnd.Next(1, 999999) * 0.95,
                    C = rnd.Next(1, 999999) * 0.95,

                    L = rnd.Next(1, 999999) * 0.95,
                    M = rnd.Next(1, 999999) * 0.95,
                    N = rnd.Next(1, 999999) * 0.95,
                    O = rnd.Next(1, 999999) * 0.95,
                    P = rnd.Next(1, 999999) * 0.95,
                    Q = rnd.Next(1, 999999) * 0.95,
                    R = rnd.Next(1, 999999) * 0.95,
                    S = rnd.Next(1, 999999) * 0.95,
                    T = rnd.Next(1, 999999) * 0.95,
                    U = rnd.Next(1, 999999) * 0.95,
                    V = rnd.Next(1, 999999) * 0.95,
                    W = rnd.Next(1, 999999) * 0.95,
                    X = rnd.Next(1, 999999) * 0.95,
                    Y = rnd.Next(1, 999999) * 0.95,
                    Z = rnd.Next(1, 999999) * 0.95,
                    AA = rnd.Next(1, 999999) * 0.95,
                    AB = rnd.Next(1, 999999) * 0.95,
                    AC = rnd.Next(1, 999999) * 0.95,
                    AD = rnd.Next(1, 999999) * 0.95,
                    AE = rnd.Next(1, 999999) * 0.95,
                    AF = rnd.Next(1, 999999) * 0.95,
                    AG = rnd.Next(1, 999999) * 0.95,
                    AH = rnd.Next(1, 999999) * 0.95,
                    AI = rnd.Next(1, 999999) * 0.95,
                    AJ = rnd.Next(1, 999999) * 0.95,
                    AK = rnd.Next(1, 999999) * 0.95,
                    AL = rnd.Next(1, 999999) * 0.95,
                    AM = rnd.Next(1, 999999) * 0.95,
                    AN = rnd.Next(1, 999999) * 0.95,
                    AO = rnd.Next(1, 999999) * 0.95,
                    AP = rnd.Next(1, 999999) * 0.95,
                    AQ = rnd.Next(1, 999999) * 0.95,
                    AR = rnd.Next(1, 999999) * 0.95,
                    AS = rnd.Next(1, 999999) * 0.95,
                    AT = rnd.Next(1, 999999) * 0.95,
                    AU = rnd.Next(1, 999999) * 0.95,
                    AV = rnd.Next(1, 999999) * 0.95,
                    AW = rnd.Next(1, 999999) * 0.95,
                    AX = rnd.Next(1, 999999) * 0.95,
                    AY = rnd.Next(1, 999999) * 0.95,
                    AZ = rnd.Next(1, 999999) * 0.95,
                    BA = rnd.Next(1, 999999) * 0.95,
                    BB = rnd.Next(1, 999999) * 0.95,
                    BC = rnd.Next(1, 999999) * 0.95,
                    BD = rnd.Next(1, 999999) * 0.95,
                    BE = rnd.Next(1, 999999) * 0.95,
                    BF = rnd.Next(1, 999999) * 0.95,
                    BG = rnd.Next(1, 999999) * 0.95,
                    BH = rnd.Next(1, 999999) * 0.95,
                    BI = rnd.Next(1, 999999) * 0.95,
                    BJ = rnd.Next(1, 999999) * 0.95,
                    BK = rnd.Next(1, 999999) * 0.95,
                    BL = rnd.Next(1, 999999) * 0.95,
                    BM = rnd.Next(1, 999999) * 0.95,
                    BN = rnd.Next(1, 999999) * 0.95,
                    BO = rnd.Next(1, 999999) * 0.95,
                    BP = rnd.Next(1, 999999) * 0.95,
                    BQ = rnd.Next(1, 999999) * 0.95,
                    BR = rnd.Next(1, 999999) * 0.95,
                    BS = rnd.Next(1, 999999) * 0.95,
                    BT = rnd.Next(1, 999999) * 0.95,
                    BU = rnd.Next(1, 999999) * 0.95,
                    BV = rnd.Next(1, 999999) * 0.95,
                    BW = rnd.Next(1, 999999) * 0.95,
                    BX = rnd.Next(1, 999999) * 0.95,
                    BY = rnd.Next(1, 999999) * 0.95,
                    BZ = rnd.Next(1, 999999) * 0.95,
                    CA = rnd.Next(1, 999999) * 0.95,
                    CB = rnd.Next(1, 999999) * 0.95,
                    CC = rnd.Next(1, 999999) * 0.95,
                    CD = rnd.Next(1, 999999) * 0.95,
                    CE = rnd.Next(1, 999999) * 0.95,
                    CF = rnd.Next(1, 999999) * 0.95,
                    CG = rnd.Next(1, 999999) * 0.95,
                    CH = rnd.Next(1, 999999) * 0.95,
                    CI = rnd.Next(1, 999999) * 0.95,
                    CJ = rnd.Next(1, 999999) * 0.95,
                    CK = rnd.Next(1, 999999) * 0.95,
                    CL = rnd.Next(1, 999999) * 0.95,
                    CM = rnd.Next(1, 999999) * 0.95,
                    CN = rnd.Next(1, 999999) * 0.95,
                    CO = rnd.Next(1, 999999) * 0.95,
                    CP = rnd.Next(1, 999999) * 0.95,
                    CQ = rnd.Next(1, 999999) * 0.95,
                    CR = rnd.Next(1, 999999) * 0.95,
                    CS = rnd.Next(1, 999999) * 0.95,
                    CT = rnd.Next(1, 999999) * 0.95,
                    CU = rnd.Next(1, 999999) * 0.95,
                    CV = rnd.Next(1, 999999) * 0.95,
                    CW = rnd.Next(1, 999999) * 0.95,
                    CX = rnd.Next(1, 999999) * 0.95,
                    CY = rnd.Next(1, 999999) * 0.95,
                    CZ = rnd.Next(1, 999999) * 0.95
                });

            }

            return Data;

        }

        private List<DataStruct3> GenerateData3(Random rnd, DateTime Date)
        {

            List<DataStruct3> Data = new List<DataStruct3>();

            for (int i = 1; i <= 62; i++)
            {

                Data.Add(new DataStruct3()
                {
                    Date = Date.AddDays(i),
                    A = rnd.Next(1, 999999) * 0.95,
                    B = rnd.Next(1, 999999) * 0.95,
                    C = rnd.Next(1, 999999) * 0.95,
                    D = rnd.Next(1, 999999) * 0.95,
                    E = rnd.Next(1, 999999) * 0.95,
                    F = rnd.Next(1, 999999) * 0.95,
                    G = rnd.Next(1, 999999) * 0.95,
                    H = rnd.Next(1, 999999) * 0.95,
                    I = rnd.Next(1, 999999) * 0.95,
                    J = rnd.Next(1, 999999) * 0.95,
                    K = rnd.Next(1, 999999) * 0.95,
                    L = rnd.Next(1, 999999) * 0.95,
                    M = rnd.Next(1, 999999) * 0.95,
                    N = rnd.Next(1, 999999) * 0.95,
                    O = rnd.Next(1, 999999) * 0.95,
                    P = rnd.Next(1, 999999) * 0.95,
                    Q = rnd.Next(1, 999999) * 0.95,
                    R = rnd.Next(1, 999999) * 0.95,
                    S = rnd.Next(1, 999999) * 0.95,
                    T = rnd.Next(1, 999999) * 0.95,
                    U = rnd.Next(1, 999999) * 0.95,
                    V = rnd.Next(1, 999999) * 0.95,
                    W = rnd.Next(1, 999999) * 0.95,
                    X = rnd.Next(1, 999999) * 0.95,
                    Y = rnd.Next(1, 999999) * 0.95,
                    Z = rnd.Next(1, 999999) * 0.95,
                    AA = rnd.Next(1, 999999) * 0.95,
                    AB = rnd.Next(1, 999999) * 0.95,
                    AC = rnd.Next(1, 999999) * 0.95,
                    AD = rnd.Next(1, 999999) * 0.95,
                    AE = rnd.Next(1, 999999) * 0.95,
                    AF = rnd.Next(1, 999999) * 0.95,
                    AG = rnd.Next(1, 999999) * 0.95,
                    AH = rnd.Next(1, 999999) * 0.95,
                    AI = rnd.Next(1, 999999) * 0.95,
                    AJ = rnd.Next(1, 999999) * 0.95,
                    AK = rnd.Next(1, 999999) * 0.95,
                    AL = rnd.Next(1, 999999) * 0.95,
                    AM = rnd.Next(1, 999999) * 0.95,
                    AN = rnd.Next(1, 999999) * 0.95,
                    AO = rnd.Next(1, 999999) * 0.95,
                    AP = rnd.Next(1, 999999) * 0.95,
                    AQ = rnd.Next(1, 999999) * 0.95,
                    AR = rnd.Next(1, 999999) * 0.95,
                    AS = rnd.Next(1, 999999) * 0.95,
                    AT = rnd.Next(1, 999999) * 0.95,
                    AU = rnd.Next(1, 999999) * 0.95,
                    AV = rnd.Next(1, 999999) * 0.95,
                    AW = rnd.Next(1, 999999) * 0.95,
                    AX = rnd.Next(1, 999999) * 0.95,
                    AY = rnd.Next(1, 999999) * 0.95,
                    AZ = rnd.Next(1, 999999) * 0.95,
                    BA = rnd.Next(1, 999999) * 0.95,
                    BB = rnd.Next(1, 999999) * 0.95,
                    BC = rnd.Next(1, 999999) * 0.95,
                    BD = rnd.Next(1, 999999) * 0.95,
                    BE = rnd.Next(1, 999999) * 0.95,
                    BF = rnd.Next(1, 999999) * 0.95,
                    BG = rnd.Next(1, 999999) * 0.95,
                    BH = rnd.Next(1, 999999) * 0.95,
                    BI = rnd.Next(1, 999999) * 0.95,
                    BJ = rnd.Next(1, 999999) * 0.95,
                    BK = rnd.Next(1, 999999) * 0.95,
                    BL = rnd.Next(1, 999999) * 0.95,
                    BM = rnd.Next(1, 999999) * 0.95,
                    BN = rnd.Next(1, 999999) * 0.95,
                    BO = rnd.Next(1, 999999) * 0.95,
                    BP = rnd.Next(1, 999999) * 0.95,
                    BQ = rnd.Next(1, 999999) * 0.95,
                    BR = rnd.Next(1, 999999) * 0.95,
                    BS = rnd.Next(1, 999999) * 0.95,
                    BT = rnd.Next(1, 999999) * 0.95,
                    BU = rnd.Next(1, 999999) * 0.95,
                    BV = rnd.Next(1, 999999) * 0.95,
                    BW = rnd.Next(1, 999999) * 0.95,
                    BX = rnd.Next(1, 999999) * 0.95,
                    BY = rnd.Next(1, 999999) * 0.95,
                    BZ = rnd.Next(1, 999999) * 0.95,
                    CA = rnd.Next(1, 999999) * 0.95,
                    CB = rnd.Next(1, 999999) * 0.95,
                    CC = rnd.Next(1, 999999) * 0.95,
                    CD = rnd.Next(1, 999999) * 0.95,
                    CE = rnd.Next(1, 999999) * 0.95,
                    CF = rnd.Next(1, 999999) * 0.95,
                    CG = rnd.Next(1, 999999) * 0.95,
                    CH = rnd.Next(1, 999999) * 0.95,
                    CI = rnd.Next(1, 999999) * 0.95,
                    CJ = rnd.Next(1, 999999) * 0.95,
                    CK = rnd.Next(1, 999999) * 0.95,
                    CL = rnd.Next(1, 999999) * 0.95,
                    CM = rnd.Next(1, 999999) * 0.95,
                    CN = rnd.Next(1, 999999) * 0.95,
                    CO = rnd.Next(1, 999999) * 0.95,
                    CP = rnd.Next(1, 999999) * 0.95,
                    CQ = rnd.Next(1, 999999) * 0.95,
                    CR = rnd.Next(1, 999999) * 0.95,
                    CS = rnd.Next(1, 999999) * 0.95,
                    CT = rnd.Next(1, 999999) * 0.95,
                    CU = rnd.Next(1, 999999) * 0.95,
                    CV = rnd.Next(1, 999999) * 0.95,
                    CW = rnd.Next(1, 999999) * 0.95,
                    CX = rnd.Next(1, 999999) * 0.95,
                    CY = rnd.Next(1, 999999) * 0.95,
                    CZ = rnd.Next(1, 999999) * 0.95
                });

            }

            return Data;

        }

    }

    public class DataStruct : INotifyPropertyChanged
    {

        public DateTime Date { get; set; }
        public double? A { get; set; }
        public double? B { get; set; }
        public double? C { get; set; }
        public double? D { get; set; }
        public double? E { get; set; }
        public double? F { get; set; }
        public double? G { get; set; }
        public double? H { get; set; }
        public double? I { get; set; }
        public double? J { get; set; }
        public double? K { get; set; }
        public double? L { get; set; }
        public double? M { get; set; }
        public double? N { get; set; }
        public double? O { get; set; }
        public double? P { get; set; }
        public double? Q { get; set; }
        public double? R { get; set; }
        public double? S { get; set; }
        public double? T { get; set; }
        public double? U { get; set; }
        public double? V { get; set; }
        public double? W { get; set; }
        public double? X { get; set; }
        public double? Y { get; set; }
        public double? Z { get; set; }
        public double? AA { get; set; }
        public double? AB { get; set; }
        public double? AC { get; set; }
        public double? AD { get; set; }
        public double? AE { get; set; }
        public double? AF { get; set; }
        public double? AG { get; set; }
        public double? AH { get; set; }
        public double? AI { get; set; }
        public double? AJ { get; set; }
        public double? AK { get; set; }
        public double? AL { get; set; }
        public double? AM { get; set; }
        public double? AN { get; set; }
        public double? AO { get; set; }
        public double? AP { get; set; }
        public double? AQ { get; set; }
        public double? AR { get; set; }
        public double? AS { get; set; }
        public double? AT { get; set; }
        public double? AU { get; set; }
        public double? AV { get; set; }
        public double? AW { get; set; }
        public double? AX { get; set; }
        public double? AY { get; set; }
        public double? AZ { get; set; }
        public double? BA { get; set; }
        public double? BB { get; set; }
        public double? BC { get; set; }
        public double? BD { get; set; }
        public double? BE { get; set; }
        public double? BF { get; set; }
        public double? BG { get; set; }
        public double? BH { get; set; }
        public double? BI { get; set; }
        public double? BJ { get; set; }
        public double? BK { get; set; }
        public double? BL { get; set; }
        public double? BM { get; set; }
        public double? BN { get; set; }
        public double? BO { get; set; }
        public double? BP { get; set; }
        public double? BQ { get; set; }
        public double? BR { get; set; }
        public double? BS { get; set; }
        public double? BT { get; set; }
        public double? BU { get; set; }
        public double? BV { get; set; }
        public double? BW { get; set; }
        public double? BX { get; set; }
        public double? BY { get; set; }
        public double? BZ { get; set; }
        public double? CA { get; set; }
        public double? CB { get; set; }
        public double? CC { get; set; }
        public double? CD { get; set; }
        public double? CE { get; set; }
        public double? CF { get; set; }
        public double? CG { get; set; }
        public double? CH { get; set; }
        public double? CI { get; set; }
        public double? CJ { get; set; }
        public double? CK { get; set; }
        public double? CL { get; set; }
        public double? CM { get; set; }
        public double? CN { get; set; }
        public double? CO { get; set; }
        public double? CP { get; set; }
        public double? CQ { get; set; }
        public double? CR { get; set; }
        public double? CS { get; set; }
        public double? CT { get; set; }
        public double? CU { get; set; }
        public double? CV { get; set; }
        public double? CW { get; set; }
        public double? CX { get; set; }
        public double? CY { get; set; }
        public double? CZ { get; set; }

        public string XX { get; set; }

        public event PropertyChangedEventHandler PropertyChanged;
        public void OnPropertyChanged(string Prop)
        {

            if (PropertyChanged != null) PropertyChanged(this, new PropertyChangedEventArgs(Prop));

        }

    }

    public class DataStruct1 : DataStruct, INotifyPropertyChanged
    {

        private DataStruct2 Table2 { get; set; }
        private DataStruct3 Table3 { get; set; }

        public double? A { get { return Table2.A; } set { Table2.A = value; } }
        public double? B { get { return Table2.B; } set { Table2.B = value; } }
        public double? C { get { return Table2.C; } set { Table2.C = value; } }
        public double? D { get { return Table3.D; } set { Table3.D = value; } }
        public double? E { get { return Table3.E; } set { Table3.E = value; } }
        public double? F { get { return Table3.F; } set { Table3.F = value; } }

        public void AddSource2(List<DataStruct2> Source)
        {

            foreach (DataStruct2 S in Source)
            {

                if (S.Date == this.Date)
                {

                    this.Table2 = S;
                    break;

                }
                
            }

        }

        public void AddSource3(List<DataStruct3> Source)
        {

            foreach (DataStruct3 S in Source)
            {

                if (S.Date == this.Date)
                {

                    this.Table3 = S;
                    break;

                }
                
            }

        }

    }

    /// <summary>
    /// Problem block with PropertyChangedEventHandler
    /// </summary>
    public class DataStruct2 : DataStruct, INotifyPropertyChanged
    {

        private DataStruct1 Table1 { get; set; }
        private DataStruct3 Table3 { get; set; }

        private double? A_ { get; set; }
        //--this code bellow is problematical (with option LiveDataUpdateMode="AllowDataShaping" in XML)
        public double? A { get { return A_; } set { A_ = value; this.MultiPropertyChanged("A", "D", "E", "F", "G", "H", "I", "J", "K"); if (Table1 != null) Table1.OnPropertyChanged("A"); } }
        private double? B_ { get; set; }
        public double? B { get { return B_; } set { B_ = value; OnPropertyChanged("B"); if (Table1 != null) Table1.OnPropertyChanged("B"); } }
        private double? C_ { get; set; }
        public double? C { get { return C_; } set { C_ = value; OnPropertyChanged("C"); if (Table1 != null) Table1.OnPropertyChanged("C"); } }

        public double? D { get { return A + B; } }
        public double? E { get { return A + C; } }
        public double? F { get { return D + E; } }
        public double? G { get { return F + C; } }
        public double? H { get { return F + G; } }
        public double? I { get { return G + H; } }
        public double? J { get { return E + I; } }
        public double? K { get { return I + J; } }

        private void MultiPropertyChanged(params string[] Prop)
        {

            foreach (string P in Prop) OnPropertyChanged(P);

        }

        public void AddSource1(List<DataStruct1> Source)
        {

            foreach (DataStruct1 S in Source)
            {

                if (S.Date == this.Date)
                {

                    this.Table1 = S;
                    break;

                }
                
            }

        }

        public void AddSource3(List<DataStruct3> Source)
        {

            foreach (DataStruct3 S in Source)
            {

                if (S.Date == this.Date)
                {

                    this.Table3 = S;
                    break;

                }
                
            }

        }

    }

    public class DataStruct3 : DataStruct, INotifyPropertyChanged
    {

    }

    public class CustomAggregate : ISummaryAggregate
    {

        public string Date_Text_Sum { get; set; }
        public string Date_Text_Avg { get; set; }

        Action<IEnumerable, string, PropertyDescriptor> ISummaryAggregate.CalculateAggregateFunc()
        {

            return (items, property, pd) =>
            {

                if (pd.Name == "Date_Text_Sum") this.Date_Text_Sum = "Sum";
                else if (pd.Name == "Date_Text_Avg") this.Date_Text_Avg = "Average";

            };

        }

    }

}
